var ledArray = [];
var xmlhttpRecurr = null;
var alive=0;
var startupTmr=0;
var mainPwrOffOK=0;
var uniqueID=0;
var disablePage=0;
var gotReply=1;
var scriptURL="http://www.remoterig.com/1216H/steppir" ;
var ajaxTimeout=0;

function getXMLHttp( )
{
	if (window.XMLHttpRequest)
		// code for IE7+, Firefox, Chrome, Opera, Safari
		xmlhttp2=new XMLHttpRequest();
	else
		// code for IE6, IE5
		xmlhttp2=new ActiveXObject("Microsoft.XMLHTTP");

	return xmlhttp2 ;
}

function sendCmd(cmd)
{
	var url = "steppircmd?c=" + cmd + new Date().getTime();
	//var url = "http://192.168.136.220/steppircmd?c=" + cmd + new Date().getTime();

	xmlhttp = getXMLHttp() ;
	xmlhttp.open("GET",url,true);
	xmlhttp.send(null);
}


function restartTmr(tid)
{
	if (startupTmr!=0)
		clearTimeout(startupTmr);
	startupTmr=setTimeout(reCurring,tid) ;
}

function setPos(id,tp,lt,ig,dis)
{
	var o=document.getElementById(id) ;
	o.style.top=tp;
	o.style.left=lt;
	if ( typeof ig != "undefined" )
		o.src = ig ;
	if ( typeof dis != "undefined" )
		o.disabled=dis;

	return o;
}

function setButtonPos(id,tp,lt,ig,dis)
{
	var o=document.getElementById(id) ;
	if (o == null)
		return null ;
	o.style.top=tp;
	o.style.left=lt;
	if ( typeof ig != "undefined" )
		o.innerHTML='<img src="'+ig+'">';
	if ( typeof dis != "undefined" )
		o.disabled=dis;

	return o;
}


function ledHandler(indx)
{
	// Off
	if (ledArray[indx].mode==0)
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
	// On
	else if (ledArray[indx].mode==1)
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
	// Blink
	else if (ledArray[indx].mode==2)
	{
		if(ledArray[indx].state<7)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<14)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else
			ledArray[indx].state=0;
	}
	// Flash
	else if (ledArray[indx].mode==3)
	{
		if(ledArray[indx].state<2)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<4)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else if(ledArray[indx].state<6)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<12)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else
			ledArray[indx].state=0;
	}
	else
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
}

function flashHandler()
{
	for(i=0;i<=6;i++)
		ledHandler(i) ;
}

function mainpwrbtnF(e)
{
	// Main power off?
	if ( ledArray[6].mode == 0 )
		sendCmd('A');	// Yes, turn on
	else
	{
		if (mainPwrOffOK !=0)
		{
			if ( confirm('The elements are possibly not at home position, turn off main power anyway?') )
				sendCmd('B');
		}
		else
			sendCmd('B');
	}
}

function calibrateFnc(e)
{
	if ( confirm('Do you really want to calibrate the antenna?') )
		sendCmd('F') ;
}

function serialRelayFnc(e)
{
	// Serial relay off?
	if ( ledArray[3].mode == 0 )
		sendCmd('N');	// Yes, turn on
	else
		sendCmd('O');
}


function startUp(sURL)
{
	var x=50; 
	var o;

	if ( typeof sURL != "undefined" )
		scriptURL = sURL ;

	uniqueID=new Date().getTime(); 

	xmlhttpRecurr = getXMLHttp() ;

	ledArray[0] = {id:"LE1", mode:0, state:0, c:"g"};
	ledArray[1] = {id:"LE2", mode:0, state:0, c:"g"};
	ledArray[2] = {id:"LE3", mode:0, state:0, c:"g"};
	ledArray[3] = {id:"LE4", mode:0, state:0, c:"g"};
	ledArray[4] = {id:"LE5", mode:0, state:0, c:"r"};
	ledArray[5] = {id:"LE6", mode:0, state:0, c:"g"};
	ledArray[6] = {id:"LE7", mode:0, state:0, c:"r"};

	setPos("header",25,15);
	setPos("fqlabel",60,15);
	setPos("fqtxt",85,15);

	setPos("hdr1",120,25);
	setButtonPos("fineup",150,10,scriptURL+"/img/uparrow.png");
	setButtonPos("finedown",210,10,scriptURL+"/img/downarrow.png");

	setPos("hdr2",120,78);
	setButtonPos("coarseup",150,75,scriptURL+"/img/uparrow.png");
	setButtonPos("coarsedown",210,75,scriptURL+"/img/downarrow.png");

	setPos("hdr3",120,151);
	setButtonPos("bandup",150,140,scriptURL+"/img/uparrow.png");
	setButtonPos("banddown",210,140,scriptURL+"/img/downarrow.png");

	setPos("LE1",130,268,scriptURL+"/img/led2off.png");
	setPos("LE2",130,345,scriptURL+"/img/led2off.png");
	setPos("LE3",130,418,scriptURL+"/img/led2off.png");
	setPos("LE4",190,418,scriptURL+"/img/led2off.png");
	setPos("LE5",85,268,scriptURL+"/img/led2off.png");
	setPos("LET5",60,255,scriptURL+"/img/led2off.png");
	setPos("LE6",85,165,scriptURL+"/img/led2off.png");
	setPos("LET6",60,152,scriptURL+"/img/led2off.png");
	setPos("LE7",64,418,scriptURL+"/img/led2off.png");
	//setPos("LE8",190,447,scriptURL+"/img/led2off.png");

	setPos("retract",85,320);
	setPos("mainpwrbtn",85,395);
	setPos("normbtn",150,245);
	setPos("one180btn",150,320);
	setPos("b1btn",150,395);
	setPos("calibratebtn",210,320);
	setPos("serialbtn",210,395);

	setPos("msg",25,330);
	
	window.setInterval("flashHandler()", 50) ;

	reCurring();
}

function reCurring()
{
	var o;

	xmlhttpRecurr.onreadystatechange=function()
	{
		if (xmlhttpRecurr.readyState==4 && xmlhttpRecurr.status==200)
		{
			var str  = xmlhttpRecurr.responseText;
			var dta  = str.split("|") ;
			var move = 0 ;

			// 1: Online mode,2=ingen kontakt med steppIR, 1=kontakt med steppIR
			if ( dta.length >= 1 )
			{
				ledArray[5].mode=parseInt(dta[0],10);
				alive=20;	// 20=10 sek
				gotReply=1;

				if (ledArray[5].mode==1 )
					dis="";
				else
					dis="disabled";

				document.getElementById("fineup").disabled=dis ;
				document.getElementById("finedown").disabled=dis ;
				document.getElementById("coarseup").disabled=dis ;
				document.getElementById("coarsedown").disabled=dis ;
				document.getElementById("bandup").disabled=dis ;
				document.getElementById("banddown").disabled=dis ;
				document.getElementById("retract").disabled=dis ;
				document.getElementById("normbtn").disabled=dis ;
				document.getElementById("one180btn").disabled=dis ;
				document.getElementById("b1btn").disabled=dis ;
				document.getElementById("calibratebtn").disabled=dis ;
			}

			// 2: Led 1=Norm-knappen
			if ( dta.length >= 2 )
				ledArray[0].mode=parseInt(dta[1],10);

			// 3: Led 2=180-knappen
			if ( dta.length >= 3 )
				ledArray[1].mode=parseInt(dta[2],10);

			// 4: Led 3=B1-knappen
			if ( dta.length >= 4 )
				ledArray[2].mode=parseInt(dta[3],10);

			// 5: Led 4=Serial-relt
			if ( dta.length >= 5 )
				ledArray[3].mode=parseInt(dta[4],10);

			// 6: Led 5=Tuning
			if ( dta.length >= 6 )
				ledArray[4].mode=parseInt(dta[5],10);

			// 7: Mode text
			/*
			if ( dta.length >= 7 )
				document.getElementById("modetxt").innerHTML=dta[6] ;
			*/

			// 8: Frekvens-text
			if ( dta.length >= 8 )
			{
				mainPwrOffOK=parseInt(dta[7].substr(0,1));
				document.getElementById("fqtxt").innerHTML=dta[7].substr(1) ;
			}

			// 9: Led 7=Main pwr
			if ( dta.length >= 9 )
				ledArray[6].mode=parseInt(dta[8],10);

			// 10: Disable hmtning
			if ( dta.length >= 10 )
				disablePage=parseInt(dta[9],10);

			//restartTmr(500);
			return ;
		}
	}

	// Fortfarande kontakt med switchen och main pwr p?
	if ( alive )
	{
		if( --alive == 0 )
			ledArray[5].mode=0; // Nej
	}
	else
	{
		// Ingen kontakt
		for(i=0;i<=6;i++)
			ledArray[i].mode=0;

		//document.getElementById("modetxt").innerHTML= "-" ;
		document.getElementById("fqtxt").innerHTML  = "-" ;
	}

	// Ny hmtning tillten?		
	if ( disablePage == 0 )
	{
		if ( gotReply )
		{
			gotReply = 0;
			var url = "steppirdta.srv?d=N" + uniqueID + "D" + new Date().getTime();
			xmlhttpRecurr.open("GET",url,true);
			xmlhttpRecurr.send();
			ajaxTimeout=15000/500 ;	// 15 secs timeout
			document.getElementById("msg").innerHTML  = "" ;
		}
		else
		{
			if ( ajaxTimeout )
			{
				if ( --ajaxTimeout == 0 )
				{
					// Makes another ajax reload happen
					gotReply = 1 ; 
					// Abort any pending request
					if ( xmlhttpRecurr != null )
						xmlhttpRecurr.abort() ;
				}
			}
		}
	}
	else
		document.getElementById("msg").innerHTML  = "<b>Page Offline!</b>" ;

	restartTmr(500);
}
